<template>
  <div>
    <banner></banner>
    <div class="content">
      <h3 class="d-flex justify-content-center mt-1 bg-danger text-light">
        Todos produtos
      </h3>
    </div>
    <div class>
      <div class="card-group d-flex justify-content-center">
        <tr v-for="produto in produtos" v-bind:key="produto.id">
          <div class="card border-danger m-2">
            <img v-if="produto.imagem" class="card-img-top rounded mx-auto d-block" :src="produto.imagem" />
            <img v-else class="card-img-top rounded mx-auto d-block" src="/img/default.jpg" />
            <div class="card-body">
              <small>Cód: {{produto.id}}</small>,
              <small>Unidade: {{produto.unidade}}</small>

              <h5 class="card-title text-dark" :title="produto.nome">{{produto.nome}}</h5>
              <div id="preco" class="text-danger">R$: {{produto.valor_venda | estiloMoeda}}</div>
              <div class="center">
                  <vue-numeric-input
                    id="quant" align="center" v-model="produto.quant_compra"
                    :max="produto.quant" :min="0" placeholder=0>
                  </vue-numeric-input>
              </div>
              <div class="mt-2 d-flex justify-content-center">
                  <button v-if="produto.quant" class="btn btn-sm btn-success" title="Adicionar ao Carrinho"
                  @click="adicionar(produto)">Adicionar ao carrinho</button>
                  <div v-else class="btn btn-sm btn-danger" disabled style="cursor: default">Produto sem estoque</div>
              </div>
              <!-- <small class="d-flex justify-content-center">Em estoque: {{produto.quant}}</small> -->
            </div>
            <!-- <div class="card-footer">
            </div>
            -->
          </div>
        </tr>
      </div>
    </div>
  </div>
</template>
<script>
import axios from "axios";
import EventBus from "./event-bus";
import banner from './banner.vue';
export default {
  components: { banner },
  data() {
    return {
      produtos: [],
      pesquisa: "",
    };
  },

  methods: {
    updateCarrinho(produto, quant) {
      EventBus.$emit("updateCarrinho", produto, quant);
    },
    async adicionar(produto) {
      if(localStorage['token'] == null ) {
       if(confirm("Ops, tente fazer o login na Ferragem Luz antes de realizar a compra.")){
          window.location.href = "/entrar"
       }
      } else {
         if(produto.quant_compra > 0) {

          axios.get(this.$urlAPI + "/pedido/" + localStorage['id'])
            .then((res)=> {
              if(res.data[0]){
                let item = {
                  produto_id: produto.id,
                  quant_compra: produto.quant_compra, 
                  pedido_id: res.data[0].id,
                }
                console.log(item);
                axios.post(this.$urlAPI + "/carrinho", item)
              }
              else {
                let pedido = {
                  status: "aberto",
                  id_cliente: localStorage['id']
                }
                axios.post(this.$urlAPI + "/pedido", pedido).then((res)=> {
                  console.log(res);
                  let item = {
                    produto_id: produto.id,
                    quant_compra: produto.quant_compra, 
                    pedido_id: res.data.id,
                  }
                  console.log(item);  
                  axios.post(this.$urlAPI + "/carrinho", item).then(
                    alert('Produto adicionado ao carrinho')
                  )
                })
                // pedido: {
                //   status: 'aberto'
                // }
                // let resp = await axios.post(this.$urlAPI + "/pedido", this.pedido)
              }
            })

        
        }
      }
    },
    listar() {
      axios
        .get(this.$urlAPI + "/produtos")
        .then((response) => (this.produtos = response.data));
    },

    todosprodutos() {
      console.log(this.pesquisa);
      axios
        .get(this.$urlAPI + `/produtos`)
        .then((response) => (this.produtos = response.data));
    },
  },
  mounted() {
    this.listar();
  },
  filters: {
    estiloMoeda(value) {
      return value.toLocaleString("pt-br", { minimumFractionDigits: 2 });
    },
  },
  props: { banner: Boolean },
};
</script>
<style scoped>
img.card-img-top {
  width: 180px;
  height: 150px;
}

#preco {
  font-size: 23px;
  font-weight: bold;
}
</style>
